#include <allegro.h>
#include "zero.h"

DATAFILE* data;
BITMAP* backg;
BITMAP* FrameBuf;
PALETTE palette;
MIDI* CurrentMusic;

int GRAVITY = 1;

RLE_SPRITE* ZeroAni[20];
int Animate = 8;

void DrawScreen()
{
 vsync();
 blit(FrameBuf,screen,0,0,0,0,320,200);	
}

void DecideAnimation(RLE_SPRITE* CurrentAni[], int size)
{
 int i;
 for( i = 0; i < size; i++)
  ZeroAni[i] = CurrentAni[i];
  
 Animate = size;
}

Character Jump(Character Zero)
{
 int i = 0;
                                                                               
 int OrigPosY = Zero.PosY;
 Zero.PosY -= 5;
 int Gravity; 
 int Animation;
 while(Zero.PosY <= OrigPosY)
 {	
  if(key[KEY_LEFT])
  {
   Zero.PosX -= 3 * Zero.Velocity;
   Zero.Facing = 0;
  }	
  if(key[KEY_RIGHT])
  {
   Zero.PosX += 3 * Zero.Velocity;	
   Zero.Facing = 1;
  }
 clear_keybuf(); 
 if(Zero.Facing)
 {
  DecideAnimation(Zero.JumpRight, 12);
 }
 else
 {
  DecideAnimation(Zero.JumpLeft, 12);
 }
 
  blit(backg,FrameBuf,0,0,0,0,320,200);

    Gravity = (10 - (GRAVITY * i));
  if(Gravity < -9) Gravity = -9;

  Animation = 0;
  if(Gravity > 9) Animation = 0;
  else if(Gravity > 1) Animation = (i % 3) + 2;
  else if(Gravity >= -1 && Gravity <= 1) Animation = 6;
  else if(Gravity < -1) Animation = (i % 4) + 7;

  draw_rle_sprite(FrameBuf,ZeroAni[Animation],Zero.PosX,Zero.PosY);
  DrawScreen(); 

  Zero.PosY = Zero.PosY - Gravity;
  if(!key[KEY_X] && i < 9) i = 9;
  i++;
  vsync();	
 }
 
 Zero.PosY = OrigPosY;
 return Zero;
}

Character MoveZero(Character Zero)
{
 if(key[KEY_X])
 {
  Zero = Jump(Zero);
 }
 else if(key[KEY_LEFT]) 
 {
  Zero.PosX -= Zero.Velocity;	
  DecideAnimation(Zero.WalkLeft, 8);
  Zero.PosY = 145;	
  Zero.Facing = 0;
 }
 else if(key[KEY_RIGHT])
 {
  Zero.PosX += Zero.Velocity;	
  DecideAnimation(Zero.WalkRight, 8);
  Zero.PosY = 145;	
  Zero.Facing = 1;
 }
 else
 {
  Zero.PosY = 141;
  if(Zero.Facing)
    DecideAnimation(Zero.StillRight, 4);
  else  
    DecideAnimation(Zero.StillLeft, 4);
 }
 
 clear_keybuf();
 return Zero;
}

void playGame(Character Zero)
{
 playMusic(ZEROX3);	
 
 int i = 0;
 DecideAnimation(Zero.StillRight, 4);
 
 while (!key[KEY_ESC]) 
 {
  blit(backg,FrameBuf,0,0,0,0,320,200);
  
  draw_rle_sprite(FrameBuf,ZeroAni[(i/5) % Animate],Zero.PosX,Zero.PosY);
  DrawScreen();
  
  Zero = MoveZero(Zero);
  
  i++;
  if(i > 1000) i = 0;
 }	
}

Character CreateZero()
{
 Character Zero;
 Zero.Velocity = 1;
 Zero.JumpLeft[0] = (RLE_SPRITE*)data[ZERO_JUMPLEFT0].dat;
 Zero.JumpLeft[1] = (RLE_SPRITE*)data[ZERO_JUMPLEFT1].dat;
 Zero.JumpLeft[2] = (RLE_SPRITE*)data[ZERO_JUMPLEFT2].dat;
 Zero.JumpLeft[3] = (RLE_SPRITE*)data[ZERO_JUMPLEFT3].dat;
 Zero.JumpLeft[4] = (RLE_SPRITE*)data[ZERO_JUMPLEFT4].dat;
 Zero.JumpLeft[5] = (RLE_SPRITE*)data[ZERO_JUMPLEFT5].dat;
 Zero.JumpLeft[6] = (RLE_SPRITE*)data[ZERO_JUMPLEFT6].dat;
 Zero.JumpLeft[7] = (RLE_SPRITE*)data[ZERO_JUMPLEFT7].dat;
 Zero.JumpLeft[8] = (RLE_SPRITE*)data[ZERO_JUMPLEFT8].dat;
 Zero.JumpLeft[9] = (RLE_SPRITE*)data[ZERO_JUMPLEFT9].dat;
 Zero.JumpLeft[10] = (RLE_SPRITE*)data[ZERO_JUMPLEFT10].dat;
 Zero.JumpLeft[11] = (RLE_SPRITE*)data[ZERO_JUMPLEFT11].dat;

 Zero.JumpRight[0] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT0].dat;
 Zero.JumpRight[1] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT1].dat;
 Zero.JumpRight[2] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT2].dat;
 Zero.JumpRight[3] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT3].dat;
 Zero.JumpRight[4] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT4].dat;
 Zero.JumpRight[5] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT5].dat;
 Zero.JumpRight[6] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT6].dat;
 Zero.JumpRight[7] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT7].dat;
 Zero.JumpRight[8] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT8].dat;
 Zero.JumpRight[9] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT9].dat;
 Zero.JumpRight[10] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT10].dat;
 Zero.JumpRight[11] = (RLE_SPRITE*)data[ZERO_JUMPRIGHT11].dat;

 Zero.LandRight[0] = (RLE_SPRITE*)data[ZERO_LANDRIGHT0].dat;
 Zero.LandRight[1] = (RLE_SPRITE*)data[ZERO_LANDRIGHT1].dat;
 Zero.LandRight[2] = (RLE_SPRITE*)data[ZERO_LANDRIGHT2].dat;
 Zero.LandRight[3] = (RLE_SPRITE*)data[ZERO_LANDRIGHT3].dat;
 
 Zero.LandLeft[0] = (RLE_SPRITE*)data[ZERO_LANDLEFT0].dat;
 Zero.LandLeft[1] = (RLE_SPRITE*)data[ZERO_LANDLEFT1].dat;
 Zero.LandLeft[2] = (RLE_SPRITE*)data[ZERO_LANDLEFT2].dat;
 Zero.LandLeft[3] = (RLE_SPRITE*)data[ZERO_LANDLEFT3].dat;
 
 Zero.StillRight[0] = (RLE_SPRITE*)data[ZERO_STILLRIGHT0].dat;
 Zero.StillRight[1] = (RLE_SPRITE*)data[ZERO_STILLRIGHT1].dat;
 Zero.StillRight[2] = (RLE_SPRITE*)data[ZERO_STILLRIGHT2].dat;
 Zero.StillRight[3] = (RLE_SPRITE*)data[ZERO_STILLRIGHT3].dat;
 
 Zero.StillLeft[0] = (RLE_SPRITE*)data[ZERO_STILLLEFT0].dat;
 Zero.StillLeft[1] = (RLE_SPRITE*)data[ZERO_STILLLEFT1].dat;
 Zero.StillLeft[2] = (RLE_SPRITE*)data[ZERO_STILLLEFT2].dat;
 Zero.StillLeft[3] = (RLE_SPRITE*)data[ZERO_STILLLEFT3].dat;
 
 Zero.WalkLeft[0] = (RLE_SPRITE*)data[ZERO_WALKLEFT0].dat;
 Zero.WalkLeft[1] = (RLE_SPRITE*)data[ZERO_WALKLEFT1].dat;
 Zero.WalkLeft[2] = (RLE_SPRITE*)data[ZERO_WALKLEFT2].dat;
 Zero.WalkLeft[3] = (RLE_SPRITE*)data[ZERO_WALKLEFT3].dat;
 Zero.WalkLeft[4] = (RLE_SPRITE*)data[ZERO_WALKLEFT4].dat;
 Zero.WalkLeft[5] = (RLE_SPRITE*)data[ZERO_WALKLEFT5].dat;
 Zero.WalkLeft[6] = (RLE_SPRITE*)data[ZERO_WALKLEFT6].dat;
 Zero.WalkLeft[7] = (RLE_SPRITE*)data[ZERO_WALKLEFT7].dat;
 
 Zero.WalkRight[0] = (RLE_SPRITE*)data[ZERO_WALKRIGHT0].dat;
 Zero.WalkRight[1] = (RLE_SPRITE*)data[ZERO_WALKRIGHT1].dat;
 Zero.WalkRight[2] = (RLE_SPRITE*)data[ZERO_WALKRIGHT2].dat;
 Zero.WalkRight[3] = (RLE_SPRITE*)data[ZERO_WALKRIGHT3].dat;
 Zero.WalkRight[4] = (RLE_SPRITE*)data[ZERO_WALKRIGHT4].dat;
 Zero.WalkRight[5] = (RLE_SPRITE*)data[ZERO_WALKRIGHT5].dat;
 Zero.WalkRight[6] = (RLE_SPRITE*)data[ZERO_WALKRIGHT6].dat;
 Zero.WalkRight[7] = (RLE_SPRITE*)data[ZERO_WALKRIGHT7].dat;
 
 Zero.PosX = 30;
 Zero.PosY = 140;	
 Zero.Velocity = 1;
 return Zero;
}


void Load_Data(char* Filename)
{
 data = load_datafile(Filename);	
}

void initGame()
{
 allegro_init();
 install_timer();
 install_keyboard();	
}

void initGraphics()
{
 set_gfx_mode(GFX_VGA,320,200,0,0);
 set_palette((RGB*)data[ZERO_PAL].dat);	
}

void initMusic()
{
 install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);	
}

void playMusic(int DATACONSTANT)
{
 CurrentMusic = (MIDI*) data[DATACONSTANT].dat; 		
 play_midi(CurrentMusic, TRUE);	
}

void noMusic()
{
 destroy_midi(CurrentMusic);
}

void Background(BITMAP* DATACONSTANT)
{
 blit(DATACONSTANT, backg, 0,0,0,0,320,200); 	
}

void initBuffers()
{
 backg = create_bitmap(320,200);
 FrameBuf=create_bitmap(320,200);
 clear(FrameBuf);	
}

void shutdown()
{
 destroy_bitmap(FrameBuf);
 destroy_bitmap(backg);
 remove_sound();
 allegro_exit();	
}

int main()
{
 initGame();
 Load_Data("zero.dat");
 initGraphics();
 initMusic(); 
 initBuffers();
 Background((BITMAP*) data[BACKG].dat);
 
 Character Zero = CreateZero(); 
 playGame(Zero);
 
 shutdown();
 return 0;
}
